int shiftPin = 8; //SHCP
int storePin = 9; //STCP
int dataPin = 10; //DS

const int PAUSE = 350;
const int ANZAHL_LEDS = 16;

int leds[ANZAHL_LEDS] = {
    0,0,0,0,0, //X
    0,0,0,0,0, //M
    0,0,0,     //A
    0,0,0,     //S
    };
 
void setup() {
 Serial.begin(9600);
 //setzen der Pins als Ausgang
 pinMode(storePin, OUTPUT);
 pinMode(shiftPin, OUTPUT);
 pinMode(dataPin, OUTPUT);

 //setzen des Pins am digitalen Pin D8
 //auf LOW quasi Status "AUS"
 digitalWrite(storePin, LOW); 
}
 
void loop () {
  //Alle "AN"
  x(1,1,1,1,1);
  m(1,1,1,1,1);
  a(1,1,1);
  s(1,1,1);
  writePattern();
  delay(PAUSE);
  //Nur "X" > "AN"
  x(1,1,1,1,1);
  m(0,0,0,0,0);
  a(0,0,0);
  s(0,0,0);
  writePattern();
  delay(PAUSE);
  //Nur "M" > "AN"
  x(0,0,0,0,0);
  m(1,1,1,1,1);
  a(0,0,0);
  s(0,0,0);
  writePattern();
  delay(PAUSE);
  //Nur "A" > "AN"
  x(0,0,0,0,0);
  m(0,0,0,0,0);
  a(1,1,1);
  s(0,0,0);
  writePattern();
  delay(PAUSE);
  //Nur "S" > "AN"
  x(0,0,0,0,0);
  m(0,0,0,0,0);
  a(0,0,0);
  s(1,1,1);
  writePattern();
  delay(PAUSE);
  
  //Nur "A" > "AN"
  x(0,0,0,0,0);
  m(0,0,0,0,0);
  a(1,1,1);
  s(0,0,0);
  writePattern();
  delay(PAUSE);
  //Nur "M" > "AN"
  x(0,0,0,0,0);
  m(1,1,1,1,1);
  a(0,0,0);
  s(0,0,0);
  writePattern();
  delay(PAUSE);
  //Nur "X" > "AN"
  x(1,1,1,1,1);
  m(0,0,0,0,0);
  a(0,0,0);
  s(0,0,0);
  writePattern();
  delay(PAUSE);

  //Zeile 1 > "AN"
  x(1,1,0,0,0);
  m(1,1,0,0,0);
  a(1,0,0);
  s(1,0,0);
  writePattern();
  delay(PAUSE);

  //Zeile 2 > "AN"
  x(0,0,1,0,0);
  m(0,0,1,0,0);
  a(0,0,0);
  s(0,1,0);
  writePattern();
  delay(PAUSE);
  
  //Zeile 3 > "AN"
  x(0,0,0,1,1);
  m(0,0,0,1,1);
  a(0,1,1);
  s(0,0,1);
  writePattern();
  delay(PAUSE);

  //Zeile 2 > "AN"
  x(0,0,1,0,0);
  m(0,0,1,0,0);
  a(0,0,0);
  s(0,1,0);
  writePattern();
  delay(PAUSE);
    
  //Zeile 1 > "AN"
  x(1,1,0,0,0);
  m(1,1,0,0,0);
  a(1,0,0);
  s(1,0,0);
  writePattern();
  delay(PAUSE);

  //Alle "AUS"
  x(0,0,0,0,0);
  m(0,0,0,0,0);
  a(0,0,0);
  s(0,0,0);
  writePattern();
  delay(PAUSE);

}

void x(int led1, int led2, int led3, int led4, int led5){
  leds[0] = led2;
  leds[1] = led1;
  leds[2] = led3;
  leds[3] = led5;
  leds[4] = led4;
}

void m(int led1, int led2, int led3, int led4, int led5){
  leds[5] = led3;
  leds[6] = led5;
  leds[7] = led4;
  leds[8] = led2;
  leds[9] = led1;
}

void a(int led1, int led2, int led3){
  leds[10] = led2;
  leds[11] = led1;
  leds[12] = led3;
}

void s(int led1, int led2, int led3){
  leds[13] = led3;
  leds[14] = led2;
  leds[15] = led1;
}

void writePattern(){
 for (int i=ANZAHL_LEDS; i>=0; i--) {
  digitalWrite(shiftPin, LOW);
  int led = leds[i];
  Serial.print(led);
  digitalWrite(dataPin, leds[i]);
  digitalWrite(shiftPin, HIGH);
 }

 digitalWrite(storePin, HIGH);  
 delay(20);
 digitalWrite(storePin, LOW);  
}
